
	# **********************************************************************
	# * name.....: ximdb
	# * version..: 1.1
	# * author...: ztx/PPX
	# * date.....: 22:36 2007/10/17
	# *
	
	
	# **********************************************************************
	# * ximdb namespace
	# *
	
	namespace eval "::ximdb" {
		
		
		# **********************************************************************
		# * ximdb settings
		# *
		
		namespace eval "variable" {
			
			# string variable trigger
			variable trigger "!imdb"
			
			# string variable dumppath
			variable dumppath "/home/perplex/eggdrop/scripts/ximdb/ximdb.dump"
			
			# list variable layout
			# %NAME%
			# %YEAR%
			# %LINK%
			# %TYPE%
			# %DIRECTOR%
			# %MPAA%
			# %RUNTIME%
			# %COUNTRY%
			# %SOUND%
			# %GENRE%
			# %TAGLINE%
			# %PLOT%
			# %RATING%
			# %VOTES%
			# %TOP250%
			variable layout {
				"\0034I\003MDb \0037x\003 \037\002%NAME%\002/%TYPE% (%YEAR%)\037"
				"\0034I\003MDb \0037x\003 Rating: %RATING% (%VOTES% votes)"
				"\0034I\003MDb \0037x\003 Top250: %TOP250%"
				"\0034I\003MDb \0037x\003 Tagline: %TAGLINE%"
				"\0034I\003MDb \0037x\003 Genre: %GENRE%"
				"\0034I\003MDb \0037x\003 \037%LINK%\037"
			}
			
			# list variable layoutx
			# %NAME%
			# %YEAR%
			# %LINK%
			# %TYPE%
			# %DIRECTOR%
			# %MPAA%
			# %RUNTIME%
			# %COUNTRY%
			# %SOUND%
			# %GENRE%
			# %TAGLINE%
			# %PLOT%
			# %RATING%
			# %VOTES%
			# %TOP250%
			variable layoutx {
				"\0034I\003MDb \0037x\003 \037\002%NAME%\002/%TYPE% (%YEAR%)\037"
				"\0034I\003MDb \0037x\003 Rating: %RATING% (%VOTES% votes)"
				"\0034I\003MDb \0037x\003 Top250: %TOP250%"
				"\0034I\003MDb \0037x\003 Tagline: %TAGLINE%"
				"\0034I\003MDb \0037x\003 Director: %DIRECTOR%"
				"\0034I\003MDb \0037x\003 Country: %COUNTRY%"
				"\0034I\003MDb \0037x\003 Genre: %GENRE%"
				"\0034I\003MDb \0037x\003 Sound: %SOUND%"
				"\0034I\003MDb \0037x\003 Runtime: %RUNTIME%"
				"\0034I\003MDb \0037x\003 MPAA: %MPAA%"
				"\0034I\003MDb \0037x\003 Plot: %PLOT%"
				"\0034I\003MDb \0037x\003 \037%LINK%\037"
			}
			
			# string variable version
			variable version "1.1"
			
			# string variable author
			variable author "ztx/PPX"
			
		}
		
		
		# **********************************************************************
		# * ximdb binds
		# *
		
		bind pub - $::ximdb::variable::trigger ::ximdb::parse::pub
		bind msg - $::ximdb::variable::trigger ::ximdb::parse::msg
		
		bind evnt - "prerehash" ::ximdb::uninstall
		
		
		# **********************************************************************
		# * ximdb parse namespace
		# *
		
		namespace eval "parse" {
		
			# void proc pub
			proc "pub" { pnick phost phandle pchannel ptext } {
				::ximdb::parse::meta $pchannel $ptext
			}
			
			# void proc msg
			proc "msg" { pnick phost phandle ptext } {
				::ximdb::parse::meta $pnick $ptext
			}
			
			# void proc meta
			proc "meta" { ptarget ptext } {
				if { [llength $ptext] == 0 } {
					::ximdb::misc::privmsg $ptarget "\002Syntax:\002 $::ximdb::variable::trigger \[-x\] <name>"
					::ximdb::misc::privmsg $ptarget "\037-x\037 Use it for extended output."
					::ximdb::misc::privmsg $ptarget "\037name\037 Can be a release or a search pattern."
					return 0
				}
				
				set name $ptext
				set layout $::ximdb::variable::layout
				
				if { [lindex $ptext 0] == "-x" } {
					set name [join [lrange $ptext 1 end]]
					set layout $::ximdb::variable::layoutx
				}
				
				set name [::ximdb::action::getname $name]
				
				putquick "PRIVMSG $ptarget :Searching for $name ..."
				
				set link [::ximdb::action::getlink $name]
				
				if { $link == 0 } {
					::ximdb::misc::privmsg $ptarget "\002Error:\002 Title not found."
					return 0
				}
				
				set details [::ximdb::action::getdetails $link]
				
				if { [lindex $details 0] == "N/A" } {
					::ximdb::misc::privmsg $ptarget "\002Error:\002 Title not found or parsing error."
					return 0
				}
				
				foreach line $layout {
					::ximdb::misc::privmsg $ptarget [string map [list "%NAME%" [lindex $details 0] \
																	  "%YEAR%" [lindex $details 1] \
																	  "%LINK%" [lindex $details 2] \
																	  "%TYPE%" [lindex $details 3] \
																	  "%DIRECTOR%" [lindex $details 4] \
																	  "%MPAA%" [lindex $details 5] \
																	  "%RUNTIME%" [lindex $details 6] \
																	  "%COUNTRY%" [lindex $details 7] \
																	  "%SOUND%" [lindex $details 8] \
																	  "%GENRE%" [lindex $details 9] \
																	  "%TAGLINE%" [lindex $details 10] \
																	  "%PLOT%" [lindex $details 11] \
																	  "%RATING%" [lindex $details 12] \
																	  "%VOTES%" [lindex $details 13] \
																	  "%TOP250%" [lindex $details 14]] $line]
				}
				
			}
			
		}
		
		
		# **********************************************************************
		# * ximdb action namespace
		# *
		
		namespace eval "action" {
			
			# string proc getname
			proc "getname" { ptext } {
				set indicator {"german" "english" "spanish" "dutch" "frensh" "polish" "swedub" "swedish" "swesub" \
							   "xxx" "dvdrip" "ld" "ts" "dl" "subbed" "line" "dubbed" "mic" "screener" "dvdscreener" "tvrip" "dtv" "proper" "limited" "custom" "crypted" "repack" "uncut" "internal" "unsubbed" "ws" "dvdscr" "satrip" "nfo" "dc" "se" "ac3" "fs" "pal" "ntsc" "multisubs" "heb" "sub" \
							   "telesync" \
							   "xvid" "divx" "vcd" "svcd" "dvdr" \
							   {19[0-9][0-9]} {20[0-9][0-9]} \
							   {s[0-9]e[0-9]} {s[0-9]e[0-9][0-9]} {s[0-9][0-9]e[0-9]} {s[0-9][0-9]e[0-9][0-9]} \
							   {e[0-9]} {e[0-9][0-9]} {e[0-9][0-9][0-9]} \
							   {[0-9]x[0-9]} {[0-9]x[0-9][0-9]} {[0-9][0-9]x[0-9]} {[0-9][0-9]x[0-9][0-9]}}
				set splitc 0
				
				if { [string match "*.*.*-*" $ptext] } {
					set splitc .
				} elseif { [string match "*-*-*-*" $ptext] } {
					set splitc -
				} elseif { [string match "*_*_*-*" $ptext] } {
					set splitc _
				} else {
					return $ptext
				}
				
				foreach word [split $ptext $splitc] {
					foreach element $indicator {
						if { [string match -nocase $element $word] } {
							return [join $name " "]
						}
					}
					
					lappend name $word
				}
			}
			
			# string proc getlink
			proc "getlink" { ptitle } {
				exec rm -f $::ximdb::variable::dumppath
				exec lynx -dump -width=1024 -connect_timeout=5 "http://www.imdb.com/find?q=[string map { " " %20 } $ptitle];tt=on;nm=on;mx=20" > $::ximdb::variable::dumppath
				
				set dump [open $::ximdb::variable::dumppath r]
				
				while { ![eof $dump] } {
					gets $dump line
					
					if { [string match *imdb.com/title/tt* $line] && ![string match *LYNXIMGMAP* $line] } {
						close $dump
						
						foreach element [split [lindex $line end] /] {
							lappend link $element
							
							if { [string match "tt*" $element] } {
								return [join $link /]
							} 
						}
					}
				}
				
				close $dump
				
				return 0
			}
			
			# list proc getdetails
			proc "getdetails" { plink } {
				exec rm -f $::ximdb::variable::dumppath
				exec lynx -dump -width=1024 -connect_timeout=5 "$plink" > $::ximdb::variable::dumppath
				
				set dump [open $::ximdb::variable::dumppath r]
				set lines [split [read $dump] "\n"]
				close $dump
				
				set dump [open $::ximdb::variable::dumppath r]
				
				set name "N/A"
				set year "N/A"
				set type "Movie"
				set director "N/A"
				set mpaa "N/A"
				set runtime "N/A"
				set country "N/A"
				set sound "N/A"
				set genre "N/A"
				set tagline "N/A"
				set plot "N/A"
				set rating "N/A"
				set votes "N/A"
				set top250 "N/A"
				
				set nr 0
				
				while { ![eof $dump] } {
					gets $dump line
					
					#-- NAME
					#-----
					#   [50]IMDb > The Matrix (1999)
					if { $name == "N/A" && [string match "*IMDb > *" $line] } {
						set nname {}
						
						foreach element [split [join [lrange [split $line] 5 end]]] {
							if { [string match {([0-9][0-9][0-9][0-9]*)} $element] } {
								set name [join $nname " "]
								set year [string range $element 1 end-1]
								break
							} else {
								lappend nname $element
							}
						}
					}
					
					#-- TYPE
					#-----
					#"Criminal Minds" ([103]2005)TV-Series 2005-????
					if { $type == "Movie" && [string match "*TV-Series*" $line] } {
						set type "TV-Series"
						set year [lindex [split $line] end]
					}
					
					
					#-- DIRECTOR
					#-----
					#Director:
					#
					#   [119]David Fincher
					if { $director == "N/A" && [string match "*Director:*" $line] } {
						set director [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- MPAA
					#-----
					#[171]MPAA:
					#
					#   Rated R for sci-fi violence and brief language.
					if { $mpaa == "N/A" && [string match "*MPAA:*" $line] } {
						set mpaa [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- RUNTIME
					#-----
					#Runtime:
					#
					#   136 min
					if { $runtime == "N/A" && [string match "*Runtime:*" $line] } {
						set runtime [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- COUNTRY
					#-----
					#Country:
					#
					#   [173]Australia / [174]USA
					if { $country == "N/A" && [string match "*Country:*" $line] } {
						set country [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- SOUND
					#-----
					#Sound Mix:
					#
					#   [185]Dolby Digital / [186]DTS-ES / [187]Dolby Digital EX
					if { $sound == "N/A" && [string match "*Sound Mix:*" $line] } {
						set sound [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- GENRE
					#-----
					#Genre:
					#
					#   [125]Action / [126]Thriller / [127]Sci-Fi [128]more
					if { $genre == "N/A" && [string match "*Genre:*" $line] } {
						set genre [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- TAGLINE
					#-----
					#Tagline:
					#
					#   In a world of 1s and 0s...are you a zero, or The One? [129]more
					if { $tagline == "N/A" && [string match "*Tagline:*" $line] } {
						set tagline [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- PLOT
					#-----
					#Plot Outline:
					#
					#   An office employee and a soap salesman build a global organization to help vent male aggression. [129]more
					if { $plot == "N/A" && [string match "*Plot Outline:*" $line] } {
						set plot [string range [lindex $lines [expr {$nr + 2}]] 3 end]
					}
					
					#-- RATING
					#-----
					#   User Rating: 8.6/10 ([109]234,685 votes)
					if { $rating == "N/A" && [string match "*User Rating:*" $line] } {
						set rating [lindex [split $line] 5]
						set votes [string range [lindex [split $line] 6] 1 end]
					}
					
					#-- TOP250
					#-----
					#   [110]Top 250: #32
					if { $top250 == "N/A" && [string match "*Top 250:*" $line] } {
						set top250 [string range [lindex [split $line] end] 1 end]
					}
					
					incr nr
				}
				
				regsub -all {\[\d+\](more)?} $director "" director
				regsub -all {\[\d+\](more)?} $mpaa "" mpaa
				regsub -all {\[\d+\](more)?} $country "" country
				regsub -all {\[\d+\](more)?} $sound "" sound
				regsub -all {\[\d+\](more)?} $genre "" genre
				regsub -all {\[\d+\](more)?} $tagline "" tagline
				regsub -all {\[\d+\](more)?} $plot "" plot
				regsub -all {\[\d+\](more)?} $votes "" votes
				
				set country [string map {" / " ", "} $country]
				set sound [string map {" / " ", "} $sound]
				set genre [string map {" / " ", "} $genre]
				
				close $dump
				
				return [list "$name" "$year" "$plink" "$type" "$director" "$mpaa" "$runtime" "$country" "$sound" "$genre" "$tagline" "$plot" "$rating" "$votes" "$top250"]
			}
			
		}
		
		
		# **********************************************************************
		# * ximdb misc namespace
		# *
		
		namespace eval "misc" {
		
			# void proc privmsg
			proc "privmsg" { ptarget pmessage } {
				if { [validchan $ptarget] && [botonchan $ptarget] && [string match "*c*" [lindex [split [getchanmode $ptarget]] 0]] } {
					puthelp "PRIVMSG $ptarget :[stripcodes bcru $pmessage]"
				} else {
					puthelp "PRIVMSG $ptarget :$pmessage"
				}
			}
			
		}
	
		
		# **********************************************************************
		# * ximdb uninstall
		# *
		
		proc uninstall { ptype } {
			foreach ubind [binds "[namespace current]::*"] {
				unbind [lindex $ubind 0] [lindex $ubind 1] [lindex $ubind 2] [lindex $ubind 4]
			}
			
			namespace delete [namespace current]
		}
		
		
		# **********************************************************************
		# * ximdb finish
		# *
		
		putlog "ximdb v$::ximdb::variable::version by $::ximdb::variable::author successfully loaded."
		
	}
